#!/bin/bash
TEST_FOLDERS=$(ls -d */)

FAILED=0

set -euox pipefail

if ! command -v jq &> /dev/null
then
  apt-get update
  apt-get install -y jq
fi

for folder in $TEST_FOLDERS
do
    dir=${folder%/}
    if [ "$dir" != "test-output" ]; then
        echo "running for $dir"
        EXPECTED=$(cat "./${dir}/output.json" | jq)
        ACTUAL=$(cd .. && stack run -- walint --repository ./test/${dir} --config-file ./config.json --json --pretty | jq && cd test) || true


        if [ "$EXPECTED" != "$ACTUAL" ]; then
            FAILED=1
            mkdir -p ./test-output
            echo "$ACTUAL" > "./test-output/${dir}.json"
            echo "$EXPECTED doenst match $ACTUAL"
        fi
    fi
done

echo "finished"
exit $FAILED
    